# -*- coding: utf-8 -*-

from decorator import decorator

__all__ = [
    "memoize_simple",
]


def memoize_simple(obj):
    cache = obj.cache = {}

    def memoizer(f, *args):
        key = args
        if key not in cache:
            cache[key] = f(*args)
        assert key in cache

        try:
            cached = cache[key]
            return cached
        except ImportError:  # pragma: no cover  # impossible to test
            del cache[key]
            cache[key] = f(*args)
            return cache[key]

            # print('memoize: %s %d storage' % (obj, len(cache)))

    return decorator(memoizer, obj)
